#! /usr/bin/wish

###Procedure###

proc get_data {fp} {
	set result_lines {}
	while {[set item [gets $fp]] ne "DATAEOF"} {
		#if {$item ne {}} {puts "ITEM:$item:$fp"}
		lappend result_lines $item
	}

	return $result_lines
}

proc send_data {fp mes} {
	puts $fp "[join $mes "\n"]\nDATAEOF\n"
	flush $fp

	return [get_data $fp]
}


proc command_fn {fp com arg} {
	#puts "FP:$fp COM:$com ARG:$arg CONCAT [concat $com $arg]"
	set ret [send_data $fp [concat $com $arg]]
	#puts "RET:$ret"
	foreach rc $ret {
		eval $rc
	}
}


proc overwrite_message {w mes} {
	$w delete 0 end
	$w insert 0 $mes

	return
}


proc LBscroll {scrollbar geoCmd offset size} {
	if {$offset != 0.0 || $size != 1.0} {
		eval $geoCmd
		$scrollbar set $offset $size
	} else {
		grid forget $scrollbar
	}
}


proc data_tcl_to_pl {header sorted_header item} {
	array set HEADER $header

	#puts "ITEM $item"
	set line {}
	foreach h $sorted_header {
		set word [lindex $item $HEADER($h)]
		set wd {}
		if {$word eq {}} {
			set word {-}
		}
		foreach w $word {
			if {$w eq {}} {
				set w {-}
			}
			set xd {}
			foreach x $w {
				if {$x eq {}} {
					set x {-}
				}
				set yd {}
				foreach y $x {
					if {$y eq {}} {
						set y {-}
					}
					lappend yd [join $y {|}]
				}
				lappend xd [join $yd {+}]
			}
			lappend wd [join $xd {&}]
		}
		lappend line [join $wd {/}]

	}

	return $line
}


###Utility
proc mkPath {root widget} {
	set path [join "$root $widget" {}]

	return $path
}


proc set_entry_value {widget value} {
	$widget delete 0 end
	$widget insert 0 $value

	return
}


proc set_ro_entry_value {widget value} {
	$widget configure -state normal
	set_entry_value $widget $value
	$widget configure -state readonly

	return
}
