/**
 * Header File of Prototype for fast_linkage.
 *@author Ryo TAKEMURA
 *@date 20130819
 */


int cnt_pedigree(FAMILY_DATA *);
FAMILY_DATA *get_genotype_data(char *, FAMILY_DATA *);
FAMILY_DATA *get_pedigree_data(char *);
double *get_penetrance_data(char *);
FAMILY_DATA *mk_new_ind(char *);
//double get_likelihood(FAMILY_DATA *, DIP *, int);
ADATA *get_founder(DIP *, int);
ADATA *get_child(DIP *, int, ADATA *);
//double get_LOD_score(FAMILY_DATA *, double *);
RLOD get_LOD_score(FAMILY_DATA *, double *, double *, double *, double);
SDATA *get_ordered_score(FAMILY_DATA *, double *, double *, double *);
double *get_risk_allele_frequency(double);
double *get_risk_genotype_frequency(double);
LINKAGE *get_linkage_analysis(FAMILY_DATA *, double *, double *, double *, double);

double get_likelihood(FAMILY_DATA *, DIP *, ADATA *, ADATA *, int, double *, double, double *, double *);
void get_likelihood_child_rec(int, RDATA *, double, FAMILY_DATA *, DIP *, ADATA *, ADATA *, int, double *, double, double *, double *);
void get_likelihood_fnd_rec(int, RDATA *, double, FAMILY_DATA *, DIP *, ADATA *, ADATA *, int, double *, double, double *, double *);
void get_likelihood_child_loop(int, RDATA *, double, FAMILY_DATA *, DIP *, ADATA *, ADATA *, int, double *, double, double *, double *);
void get_likelihood_fnd_loop(int, RDATA *, double, FAMILY_DATA *, DIP *, ADATA *, ADATA *, int, double *, double, double *, double *);
void get_likelihood_unite(RDATA *, FAMILY_DATA *, DIP *, ADATA *, ADATA *, int, double *, double, double *, double *);
void get_likelihood_fool(int, int, RDATA *, FAMILY_DATA *, DIP *, ADATA *, ADATA *, int number, double *, double theta, double *, double *);
void get_likelihood_child_fool_rec(int, RDATA *, double, FAMILY_DATA *, DIP *, ADATA *, ADATA *, int, double *, double, double *, double *);
void get_likelihood_fnd_fool_rec(int, RDATA *, double, FAMILY_DATA *, DIP *, ADATA *, ADATA *, int, double *, double, double *, double *);

